#include "MP3_Player_objects.h"
#include "MP3_Player_resources.h"

//--------------------- User code ---------------------//

#include "MP3_driver.h"


//----------------- End of User code ------------------//

// Event Handlers

void ButtonRound1OnClick() {
     if(playing == 0) {
         if (first == 1) {
           StartPlayingFile(&nomFichier);
           first = 0;
         }
         else ContinuePlaying();
     }
     else {
         playing = 0;
     }
     PauseButton.Active = playing;
     PauseButton.Visible = playing;
     PlayButton.Active = 1-playing;
     PlayButton.Visible = 1-playing;
     if(playing)DrawImage(&PauseButton);
     else DrawImage(&PlayButton);
}

void MasqueVolumeOnPress() {
     float vol;
     extern Ycoord;
     TextVolume.Font_Color = CL_WHITE;
     DrawLabel(&TextVolume);
     volume = Ycoord - VolumeLine.First_Point_Y;
     if (volume < 0) volume = 0;
     else if (volume > 100) volume = 100;
     volume = 100 - volume;
     sprintf(TextVolume.caption,"%d%%",volume);
     TextVolume.Font_Color = CL_BLACK;
     DrawLabel(&TextVolume);
     VolumeButton.Top = Ycoord - VolumeButton.Height/2;
     if (VolumeButton.Top < VolumeLine.First_Point_Y - VolumeButton.Height/2) VolumeButton.Top = VolumeLine.First_Point_Y - VolumeButton.Height/2;
     else if (VolumeButton.Top > VolumeLine.Second_Point_Y - VolumeButton.Height/2) VolumeButton.Top = VolumeLine.Second_Point_Y - VolumeButton.Height/2;
     DrawBox(&MasqueVolume);
     DrawLine(&VolumeLine);
     DrawRoundBox(&VolumeButton);
     if (volume < 1) volume = 1;
     if (volume != volume_old) {
        vol = (1-(log10(volume)/2.0)) * 255;
        MP3_Set_Volume(floor(vol), floor(vol));
        volume_old = volume;
     }
}

void VolumeButtonOnUp() {
     DrawLabel(&TextVolume);
}

void ProgressMasqueOnPress() {
     extern Xcoord;
     int position = 0;
     long int temp = 0;
     playing = 0;
     if (Xcoord < ProgressBar1.Left-ProgressButton.Width/2) position = ProgressBar1.Left-ProgressButton.Width/2;
     else if (Xcoord > ProgressBar1.Left+ProgressBar1.Width-ProgressButton.Width/2) position = ProgressBar1.Left+ProgressBar1.Width-ProgressButton.Width/2;
     else position = Xcoord - ProgressButton.Width/2;
     ProgressButton.Left = position;
     DrawBox(&ProgressMasque);
     DrawProgressBar(&ProgressBar1);
     DrawRoundBox(&ProgressButton);
     temp = position/(ProgressBar1.Left+ProgressBar1.Width-(ProgressButton.Width/2.))*total_file_size;
     //temp -= temp % 32;
     ChangePosition(temp);
     file_size = total_file_size - temp;
     ContinuePlaying();
}

void StopButtonOnClick() {
    int position = 0;
    PauseButton.Active = 0;
    PauseButton.Visible = 0;
    PlayButton.Active = 1;
    PlayButton.Visible = 1;
    playing = 0;
    if (FatType == 16) {
        Mmc_Fat_Reset(&file_size);
    } /*
    else if (FatType == 32) {
        FAT32_Seek(fileHandler, 0);
        file_size = total_file_size;
    }   */
    position = ProgressBar1.Left-ProgressButton.Width/2;
    ProgressBar1.position = 0;
    ProgressButton.Left = position;
    DrawBox(&ProgressMasque);
    DrawProgressBar(&ProgressBar1);
    DrawRoundBox(&ProgressButton);
    DrawImage(&PlayButton);
}