_USB_Init_Desc:
;usbdsc.c,161 :: 		void USB_Init_Desc(){
;usbdsc.c,162 :: 		USB_config_dsc_ptr[0] = &configDescriptor1;
LUI	R2, #hi_addr(_configDescriptor1+0)
ORI	R2, R2, #lo_addr(_configDescriptor1+0)
SW	R2, Offset(_USB_config_dsc_ptr+0)(GP)
;usbdsc.c,163 :: 		USB_string_dsc_ptr[0] = (const char*)&strd1;
LUI	R2, #hi_addr(_strd1+0)
ORI	R2, R2, #lo_addr(_strd1+0)
SW	R2, Offset(_USB_string_dsc_ptr+0)(GP)
;usbdsc.c,164 :: 		USB_string_dsc_ptr[1] = (const char*)&strd2;
LUI	R2, #hi_addr(_strd2+0)
ORI	R2, R2, #lo_addr(_strd2+0)
SW	R2, Offset(_USB_string_dsc_ptr+4)(GP)
;usbdsc.c,165 :: 		USB_string_dsc_ptr[2] = (const char*)&strd3;
LUI	R2, #hi_addr(_strd3+0)
ORI	R2, R2, #lo_addr(_strd3+0)
SW	R2, Offset(_USB_string_dsc_ptr+8)(GP)
;usbdsc.c,166 :: 		}
L_end_USB_Init_Desc:
JR	RA
NOP	
; end of _USB_Init_Desc
_ViderBuffer:
;MP3_Player_main.c,38 :: 		void ViderBuffer(char * buffer, int len)
;MP3_Player_main.c,40 :: 		int i = 0;
;MP3_Player_main.c,41 :: 		for (i=0; i<len;i++) *(buffer+i) = 0;
; i start address is: 16 (R4)
MOVZ	R4, R0, R0
; i end address is: 16 (R4)
L_ViderBuffer0:
; i start address is: 16 (R4)
SEH	R3, R4
SEH	R2, R26
SLT	R2, R3, R2
BNE	R2, R0, L__ViderBuffer45
NOP	
J	L_ViderBuffer1
NOP	
L__ViderBuffer45:
SEH	R2, R4
ADDU	R2, R25, R2
SB	R0, 0(R2)
ADDIU	R2, R4, 1
SEH	R4, R2
; i end address is: 16 (R4)
J	L_ViderBuffer0
NOP	
L_ViderBuffer1:
;MP3_Player_main.c,42 :: 		}
L_end_ViderBuffer:
JR	RA
NOP	
; end of _ViderBuffer
_USB_Isr:
;MP3_Player_main.c,44 :: 		void USB_Isr() iv IVT_USB_1 ilevel 7 ics ICS_SRS {
RDPGPR	SP, SP
ADDIU	SP, SP, -12
MFC0	R30, 12, 2
SW	R30, 8(SP)
MFC0	R30, 14, 0
SW	R30, 4(SP)
MFC0	R30, 12, 0
SW	R30, 0(SP)
INS	R30, R0, 1, 15
ORI	R30, R0, 7168
MTC0	R30, 12, 0
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;MP3_Player_main.c,45 :: 		USB_Interrupt_Proc();
JAL	_USB_Interrupt_Proc+0
NOP	
;MP3_Player_main.c,46 :: 		USBIF_bit = 0;
LUI	R2, BitMask(USBIF_bit+0)
ORI	R2, R2, BitMask(USBIF_bit+0)
_SX	8, Offset(USBIF_bit+4), 4
;MP3_Player_main.c,47 :: 		}
L_end_USB_Isr:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
DI	
EHB	
LW	R30, 8(SP)
MTC0	R30, 12, 2
LW	R30, 4(SP)
MTC0	R30, 14, 0
LW	R30, 0(SP)
MTC0	R30, 12, 0
ADDIU	SP, SP, 12
WRPGPR	SP, SP
ERET	
; end of _USB_Isr
_PrintChar:
;MP3_Player_main.c,49 :: 		void PrintChar(char ch) {
ADDIU	SP, SP, -16
SW	RA, 0(SP)
;MP3_Player_main.c,60 :: 		if (ind_dir == 0) {
SW	R25, 4(SP)
SW	R26, 8(SP)
LH	R2, Offset(_ind_dir+0)(GP)
BEQ	R2, R0, L__PrintChar48
NOP	
J	L_PrintChar3
NOP	
L__PrintChar48:
;MP3_Player_main.c,61 :: 		is_dir = 0;
SH	R0, Offset(_is_dir+0)(GP)
;MP3_Player_main.c,62 :: 		is_file = 0;
SH	R0, Offset(_is_file+0)(GP)
;MP3_Player_main.c,63 :: 		cr_found = 0;
SH	R0, Offset(_cr_found+0)(GP)
;MP3_Player_main.c,64 :: 		ViderBuffer(filename,FILENAME_LEN);
SB	R25, 12(SP)
ORI	R26, R0, 12
LUI	R25, #hi_addr(_filename+0)
ORI	R25, R25, #lo_addr(_filename+0)
JAL	_ViderBuffer+0
NOP	
LBU	R25, 12(SP)
;MP3_Player_main.c,65 :: 		}
L_PrintChar3:
;MP3_Player_main.c,66 :: 		if (ch == '\r') {
ANDI	R3, R25, 255
ORI	R2, R0, 13
BEQ	R3, R2, L__PrintChar49
NOP	
J	L_PrintChar4
NOP	
L__PrintChar49:
;MP3_Player_main.c,67 :: 		cr_found = 1;
ORI	R2, R0, 1
SH	R2, Offset(_cr_found+0)(GP)
;MP3_Player_main.c,68 :: 		}
L_PrintChar4:
;MP3_Player_main.c,69 :: 		if ((ind_dir == IS_FILE_ATTR)&&(ch != '-')) is_file = 1;
LH	R3, Offset(_ind_dir+0)(GP)
ORI	R2, R0, 2
BEQ	R3, R2, L__PrintChar50
NOP	
J	L__PrintChar36
NOP	
L__PrintChar50:
ANDI	R3, R25, 255
ORI	R2, R0, 45
BNE	R3, R2, L__PrintChar52
NOP	
J	L__PrintChar35
NOP	
L__PrintChar52:
L__PrintChar34:
ORI	R2, R0, 1
SH	R2, Offset(_is_file+0)(GP)
L__PrintChar36:
L__PrintChar35:
;MP3_Player_main.c,70 :: 		if ((ind_dir == IS_DIR_ATTR)&&(ch != '-')) is_dir = 1;
LH	R3, Offset(_ind_dir+0)(GP)
ORI	R2, R0, 3
BEQ	R3, R2, L__PrintChar53
NOP	
J	L__PrintChar38
NOP	
L__PrintChar53:
ANDI	R3, R25, 255
ORI	R2, R0, 45
BNE	R3, R2, L__PrintChar55
NOP	
J	L__PrintChar37
NOP	
L__PrintChar55:
L__PrintChar33:
ORI	R2, R0, 1
SH	R2, Offset(_is_dir+0)(GP)
L__PrintChar38:
L__PrintChar37:
;MP3_Player_main.c,71 :: 		if ((ind_dir >= FILE_NAME_START_POS)&&(cr_found==0)) filename[ind_dir - FILE_NAME_START_POS] = ch;
LH	R2, Offset(_ind_dir+0)(GP)
SLTI	R2, R2, 39
BEQ	R2, R0, L__PrintChar56
NOP	
J	L__PrintChar40
NOP	
L__PrintChar56:
LH	R2, Offset(_cr_found+0)(GP)
BEQ	R2, R0, L__PrintChar57
NOP	
J	L__PrintChar39
NOP	
L__PrintChar57:
L__PrintChar32:
LH	R2, Offset(_ind_dir+0)(GP)
ADDIU	R2, R2, -39
SEH	R3, R2
LUI	R2, #hi_addr(_filename+0)
ORI	R2, R2, #lo_addr(_filename+0)
ADDU	R2, R2, R3
SB	R25, 0(R2)
L__PrintChar40:
L__PrintChar39:
;MP3_Player_main.c,72 :: 		ind_dir++;
LH	R2, Offset(_ind_dir+0)(GP)
ADDIU	R2, R2, 1
SH	R2, Offset(_ind_dir+0)(GP)
;MP3_Player_main.c,73 :: 		if (ch=='\n'){
ANDI	R3, R25, 255
ORI	R2, R0, 10
BEQ	R3, R2, L__PrintChar58
NOP	
J	L_PrintChar14
NOP	
L__PrintChar58:
;MP3_Player_main.c,74 :: 		ind_dir = 0;
SH	R0, Offset(_ind_dir+0)(GP)
;MP3_Player_main.c,75 :: 		if ((is_dir==1)||(is_file==1)){
LH	R3, Offset(_is_dir+0)(GP)
ORI	R2, R0, 1
BNE	R3, R2, L__PrintChar60
NOP	
J	L__PrintChar42
NOP	
L__PrintChar60:
LH	R3, Offset(_is_file+0)(GP)
ORI	R2, R0, 1
BNE	R3, R2, L__PrintChar62
NOP	
J	L__PrintChar41
NOP	
L__PrintChar62:
J	L_PrintChar17
NOP	
L__PrintChar42:
L__PrintChar41:
;MP3_Player_main.c,76 :: 		sprintf(WriteBuffer, "%s\r\n", filename);
LUI	R4, #hi_addr(?lstr_1_MP3_Player_main+0)
ORI	R4, R4, #lo_addr(?lstr_1_MP3_Player_main+0)
LUI	R3, #hi_addr(_WriteBuffer+0)
ORI	R3, R3, #lo_addr(_WriteBuffer+0)
LUI	R2, #hi_addr(_filename+0)
ORI	R2, R2, #lo_addr(_filename+0)
ADDIU	SP, SP, -12
SW	R2, 8(SP)
SW	R4, 4(SP)
SW	R3, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;MP3_Player_main.c,77 :: 		HID_Write(WriteBuffer, USB_LEN);
ORI	R26, R0, 64
LUI	R25, #hi_addr(_WriteBuffer+0)
ORI	R25, R25, #lo_addr(_WriteBuffer+0)
JAL	_HID_Write+0
NOP	
;MP3_Player_main.c,78 :: 		}
L_PrintChar17:
;MP3_Player_main.c,79 :: 		}
L_PrintChar14:
;MP3_Player_main.c,81 :: 		}
L_end_PrintChar:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 16
JR	RA
NOP	
; end of _PrintChar
_main:
;MP3_Player_main.c,84 :: 		void main() {
ADDIU	SP, SP, -4
;MP3_Player_main.c,85 :: 		int toogle = 0;
;MP3_Player_main.c,87 :: 		file_size = 0;
SW	R0, Offset(_file_size+0)(GP)
;MP3_Player_main.c,88 :: 		total_file_size =0;
SW	R0, Offset(_total_file_size+0)(GP)
;MP3_Player_main.c,89 :: 		playing = 0;
SH	R0, Offset(_playing+0)(GP)
;MP3_Player_main.c,90 :: 		first = 1;
ORI	R2, R0, 1
SH	R2, Offset(_first+0)(GP)
;MP3_Player_main.c,91 :: 		toogle = 0;
SH	R0, 0(SP)
;MP3_Player_main.c,93 :: 		USBIP0_bit = 1;
LUI	R2, BitMask(USBIP0_bit+0)
ORI	R2, R2, BitMask(USBIP0_bit+0)
_SX	8, Offset(USBIP0_bit+8), 4
;MP3_Player_main.c,94 :: 		USBIP1_bit = 1;
LUI	R2, BitMask(USBIP1_bit+0)
ORI	R2, R2, BitMask(USBIP1_bit+0)
_SX	8, Offset(USBIP1_bit+8), 4
;MP3_Player_main.c,95 :: 		USBIP2_bit = 1;
LUI	R2, BitMask(USBIP2_bit+0)
ORI	R2, R2, BitMask(USBIP2_bit+0)
_SX	8, Offset(USBIP2_bit+8), 4
;MP3_Player_main.c,97 :: 		USBIE_bit = 1;
LUI	R2, BitMask(USBIE_bit+0)
ORI	R2, R2, BitMask(USBIE_bit+0)
_SX	8, Offset(USBIE_bit+8), 4
;MP3_Player_main.c,98 :: 		ViderBuffer(WriteBuffer, USB_LEN);
ORI	R26, R0, 64
LUI	R25, #hi_addr(_WriteBuffer+0)
ORI	R25, R25, #lo_addr(_WriteBuffer+0)
JAL	_ViderBuffer+0
NOP	
;MP3_Player_main.c,99 :: 		HID_Enable(ReadBuffer, WriteBuffer);
LUI	R26, #hi_addr(_WriteBuffer+0)
ORI	R26, R26, #lo_addr(_WriteBuffer+0)
LUI	R25, #hi_addr(_ReadBuffer+0)
ORI	R25, R25, #lo_addr(_ReadBuffer+0)
JAL	_HID_Enable+0
NOP	
;MP3_Player_main.c,101 :: 		Start_TP();
JAL	_Start_TP+0
NOP	
;MP3_Player_main.c,103 :: 		MP3_Start();
JAL	_MP3_Start+0
NOP	
;MP3_Player_main.c,104 :: 		FatType = 0;
SH	R0, Offset(_FatType+0)(GP)
;MP3_Player_main.c,105 :: 		while (FatType == 0)
L_main18:
LH	R2, Offset(_FatType+0)(GP)
BEQ	R2, R0, L__main64
NOP	
J	L_main19
NOP	
L__main64:
;MP3_Player_main.c,108 :: 		else if (FAT32_Init()==0) FatType=32;  */
JAL	_Mmc_Fat_Init+0
NOP	
ANDI	R2, R2, 255
BEQ	R2, R0, L__main65
NOP	
J	L_main20
NOP	
L__main65:
ORI	R2, R0, 16
SH	R2, Offset(_FatType+0)(GP)
J	L_main21
NOP	
L_main20:
;MP3_Player_main.c,109 :: 		else FatType=0;
SH	R0, Offset(_FatType+0)(GP)
L_main21:
;MP3_Player_main.c,111 :: 		if (toogle == 1){
LH	R3, 0(SP)
ORI	R2, R0, 1
BEQ	R3, R2, L__main66
NOP	
J	L_main22
NOP	
L__main66:
;MP3_Player_main.c,112 :: 		TFT_Set_Font(TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);
MOVZ	R27, R0, R0
MOVZ	R26, R0, R0
LUI	R25, #hi_addr(_TFT_defaultFont+0)
ORI	R25, R25, #lo_addr(_TFT_defaultFont+0)
JAL	_TFT_Set_Font+0
NOP	
;MP3_Player_main.c,113 :: 		toogle = 0;
SH	R0, 0(SP)
;MP3_Player_main.c,114 :: 		}
J	L_main23
NOP	
L_main22:
;MP3_Player_main.c,116 :: 		TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
MOVZ	R27, R0, R0
ORI	R26, R0, 65535
LUI	R25, #hi_addr(_TFT_defaultFont+0)
ORI	R25, R25, #lo_addr(_TFT_defaultFont+0)
JAL	_TFT_Set_Font+0
NOP	
;MP3_Player_main.c,117 :: 		toogle = 1;
ORI	R2, R0, 1
SH	R2, 0(SP)
;MP3_Player_main.c,118 :: 		}
L_main23:
;MP3_Player_main.c,119 :: 		TFT_Write_Text("Mounting SD ...", 100, 100);
ORI	R27, R0, 100
ORI	R26, R0, 100
LUI	R25, #hi_addr(?lstr2_MP3_Player_main+0)
ORI	R25, R25, #lo_addr(?lstr2_MP3_Player_main+0)
JAL	_TFT_Write_Text+0
NOP	
;MP3_Player_main.c,120 :: 		Delay_ms(200);
LUI	R24, 81
ORI	R24, R24, 24916
L_main24:
ADDIU	R24, R24, -1
BNE	R24, R0, L_main24
NOP	
NOP	
NOP	
;MP3_Player_main.c,121 :: 		}
J	L_main18
NOP	
L_main19:
;MP3_Player_main.c,122 :: 		TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
MOVZ	R27, R0, R0
ORI	R26, R0, 65535
LUI	R25, #hi_addr(_TFT_defaultFont+0)
ORI	R25, R25, #lo_addr(_TFT_defaultFont+0)
JAL	_TFT_Set_Font+0
NOP	
;MP3_Player_main.c,123 :: 		TFT_Write_Text("Mounting SD ...", 100, 100);
ORI	R27, R0, 100
ORI	R26, R0, 100
LUI	R25, #hi_addr(?lstr3_MP3_Player_main+0)
ORI	R25, R25, #lo_addr(?lstr3_MP3_Player_main+0)
JAL	_TFT_Write_Text+0
NOP	
;MP3_Player_main.c,125 :: 		strcpy(&nomFichier,"SOUND.MP3");
LUI	R26, #hi_addr(?lstr4_MP3_Player_main+0)
ORI	R26, R26, #lo_addr(?lstr4_MP3_Player_main+0)
LUI	R25, #hi_addr(_nomFichier+0)
ORI	R25, R25, #lo_addr(_nomFichier+0)
JAL	_strcpy+0
NOP	
;MP3_Player_main.c,127 :: 		while (1) {
L_main26:
;MP3_Player_main.c,128 :: 		ProgressMasque.Active = playing;
LH	R2, Offset(_playing+0)(GP)
SB	R2, Offset(_ProgressMasque+19)(GP)
;MP3_Player_main.c,129 :: 		Check_TP();
JAL	_Check_TP+0
NOP	
;MP3_Player_main.c,130 :: 		if (HID_Read())
JAL	_HID_Read+0
NOP	
BNE	R2, R0, L__main68
NOP	
J	L_main28
NOP	
L__main68:
;MP3_Player_main.c,132 :: 		if (strstr(ReadBuffer, "dir")) {
LUI	R26, #hi_addr(?lstr5_MP3_Player_main+0)
ORI	R26, R26, #lo_addr(?lstr5_MP3_Player_main+0)
LUI	R25, #hi_addr(_ReadBuffer+0)
ORI	R25, R25, #lo_addr(_ReadBuffer+0)
JAL	_strstr+0
NOP	
BNE	R2, R0, L__main70
NOP	
J	L_main29
NOP	
L__main70:
;MP3_Player_main.c,133 :: 		ViderBuffer(ReadBuffer, USB_LEN);
ORI	R26, R0, 64
LUI	R25, #hi_addr(_ReadBuffer+0)
ORI	R25, R25, #lo_addr(_ReadBuffer+0)
JAL	_ViderBuffer+0
NOP	
;MP3_Player_main.c,134 :: 		ind_dir = 0;
SH	R0, Offset(_ind_dir+0)(GP)
;MP3_Player_main.c,135 :: 		ViderBuffer(WriteBuffer, USB_LEN);
ORI	R26, R0, 64
LUI	R25, #hi_addr(_WriteBuffer+0)
ORI	R25, R25, #lo_addr(_WriteBuffer+0)
JAL	_ViderBuffer+0
NOP	
;MP3_Player_main.c,136 :: 		Mmc_Fat_Dir(PrintChar);
LUI	R25, #hi_addr(_PrintChar+0)
ORI	R25, R25, #lo_addr(_PrintChar+0)
JAL	_Mmc_Fat_Dir+0
NOP	
;MP3_Player_main.c,138 :: 		}
L_main29:
;MP3_Player_main.c,139 :: 		if (strstr(ReadBuffer, "cd ")) {
LUI	R26, #hi_addr(?lstr6_MP3_Player_main+0)
ORI	R26, R26, #lo_addr(?lstr6_MP3_Player_main+0)
LUI	R25, #hi_addr(_ReadBuffer+0)
ORI	R25, R25, #lo_addr(_ReadBuffer+0)
JAL	_strstr+0
NOP	
BNE	R2, R0, L__main72
NOP	
J	L_main30
NOP	
L__main72:
;MP3_Player_main.c,140 :: 		Mmc_Fat_ChangeDir(ReadBuffer+strlen("cd "));
LUI	R25, #hi_addr(?lstr7_MP3_Player_main+0)
ORI	R25, R25, #lo_addr(?lstr7_MP3_Player_main+0)
JAL	_strlen+0
NOP	
SEH	R3, R2
LUI	R2, #hi_addr(_ReadBuffer+0)
ORI	R2, R2, #lo_addr(_ReadBuffer+0)
ADDU	R2, R2, R3
MOVZ	R25, R2, R0
JAL	_Mmc_Fat_ChangeDir+0
NOP	
;MP3_Player_main.c,141 :: 		strcpy(WriteBuffer, "OK");
LUI	R26, #hi_addr(?lstr8_MP3_Player_main+0)
ORI	R26, R26, #lo_addr(?lstr8_MP3_Player_main+0)
LUI	R25, #hi_addr(_WriteBuffer+0)
ORI	R25, R25, #lo_addr(_WriteBuffer+0)
JAL	_strcpy+0
NOP	
;MP3_Player_main.c,142 :: 		HID_Write(WriteBuffer, USB_LEN);
ORI	R26, R0, 64
LUI	R25, #hi_addr(_WriteBuffer+0)
ORI	R25, R25, #lo_addr(_WriteBuffer+0)
JAL	_HID_Write+0
NOP	
;MP3_Player_main.c,143 :: 		ViderBuffer(ReadBuffer, USB_LEN);
ORI	R26, R0, 64
LUI	R25, #hi_addr(_ReadBuffer+0)
ORI	R25, R25, #lo_addr(_ReadBuffer+0)
JAL	_ViderBuffer+0
NOP	
;MP3_Player_main.c,144 :: 		ViderBuffer(WriteBuffer, USB_LEN);
ORI	R26, R0, 64
LUI	R25, #hi_addr(_WriteBuffer+0)
ORI	R25, R25, #lo_addr(_WriteBuffer+0)
JAL	_ViderBuffer+0
NOP	
;MP3_Player_main.c,145 :: 		}
L_main30:
;MP3_Player_main.c,146 :: 		}
L_main28:
;MP3_Player_main.c,147 :: 		}
J	L_main26
NOP	
;MP3_Player_main.c,149 :: 		}
L_end_main:
L__main_end_loop:
J	L__main_end_loop
NOP	
; end of _main
