_MP3_SCI_Write:
;MP3_driver.c,104 :: 		void MP3_SCI_Write(char address, unsigned int data_in) {
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;MP3_driver.c,105 :: 		BSYNC = 1;
SW	R25, 4(SP)
SH	R26, 10(SP)
LUI	R2, BitMask(LATB8_bit+0)
ORI	R2, R2, BitMask(LATB8_bit+0)
_SX	8, Offset(LATB8_bit+8), 4
;MP3_driver.c,107 :: 		MP3_CS = 0;                    // select MP3 SCI
LUI	R2, BitMask(LATG15_bit+0)
ORI	R2, R2, BitMask(LATG15_bit+0)
_SX	8, Offset(LATG15_bit+4), 4
;MP3_driver.c,108 :: 		SPI2_Write(WRITE_CODE);
SB	R25, 8(SP)
ORI	R25, R0, 2
JAL	_SPI2_Write+0
NOP	
LBU	R25, 8(SP)
;MP3_driver.c,109 :: 		SPI2_Write(address);
ANDI	R25, R25, 255
JAL	_SPI2_Write+0
NOP	
;MP3_driver.c,110 :: 		SPI2_Write(Hi(data_in));       // high byte
ADDIU	R2, SP, 10
ADDIU	R2, R2, 1
LBU	R25, 0(R2)
JAL	_SPI2_Write+0
NOP	
;MP3_driver.c,111 :: 		SPI2_Write(Lo(data_in));       // low byte
ADDIU	R2, SP, 10
LBU	R25, 0(R2)
JAL	_SPI2_Write+0
NOP	
;MP3_driver.c,112 :: 		MP3_CS = 1;                    // deselect MP3 SCI
LUI	R2, BitMask(LATG15_bit+0)
ORI	R2, R2, BitMask(LATG15_bit+0)
_SX	8, Offset(LATG15_bit+8), 4
;MP3_driver.c,113 :: 		while (DREQ == 0);             // wait until DREQ becomes 1, see MP3 codec datasheet, Serial Protocol for SCI
L_MP3_SCI_Write0:
_LX	, 4
EXT	R2, R2, BitPos(RD8_bit+0), 1
BEQ	R2, R0, L__MP3_SCI_Write67
NOP	
J	L_MP3_SCI_Write1
NOP	
L__MP3_SCI_Write67:
J	L_MP3_SCI_Write0
NOP	
L_MP3_SCI_Write1:
;MP3_driver.c,114 :: 		}
L_end_MP3_SCI_Write:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _MP3_SCI_Write
_MP3_SCI_Read:
;MP3_driver.c,123 :: 		void MP3_SCI_Read(char start_address, char words_count, unsigned int *data_buffer) {
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;MP3_driver.c,126 :: 		MP3_CS = 0;                    // select MP3 SCI
LUI	R2, BitMask(LATG15_bit+0)
ORI	R2, R2, BitMask(LATG15_bit+0)
_SX	8, Offset(LATG15_bit+4), 4
;MP3_driver.c,127 :: 		SPI2_Write(READ_CODE);
SB	R25, 4(SP)
ORI	R25, R0, 3
JAL	_SPI2_Write+0
NOP	
LBU	R25, 4(SP)
;MP3_driver.c,128 :: 		SPI2_Write(start_address);
ANDI	R25, R25, 255
JAL	_SPI2_Write+0
NOP	
;MP3_driver.c,130 :: 		while (words_count--) {        // read words_count words byte per byte
L_MP3_SCI_Read2:
ANDI	R3, R26, 255
ADDIU	R2, R26, -1
ANDI	R26, R2, 255
BNE	R3, R0, L__MP3_SCI_Read70
NOP	
J	L_MP3_SCI_Read3
NOP	
L__MP3_SCI_Read70:
;MP3_driver.c,131 :: 		temp = SPI2_Read(0);
SB	R25, 4(SP)
MOVZ	R25, R0, R0
JAL	_SPI2_Read+0
NOP	
;MP3_driver.c,132 :: 		temp <<= 8;
ANDI	R2, R2, 65535
SLL	R2, R2, 8
; temp start address is: 12 (R3)
ANDI	R3, R2, 65535
;MP3_driver.c,133 :: 		temp += SPI2_Read(0);
MOVZ	R25, R0, R0
JAL	_SPI2_Read+0
NOP	
LBU	R25, 4(SP)
ADDU	R2, R3, R2
; temp end address is: 12 (R3)
;MP3_driver.c,134 :: 		*(data_buffer++) = temp;
SH	R2, 0(R27)
ADDIU	R2, R27, 2
MOVZ	R27, R2, R0
;MP3_driver.c,135 :: 		}
J	L_MP3_SCI_Read2
NOP	
L_MP3_SCI_Read3:
;MP3_driver.c,136 :: 		MP3_CS = 1;                    // deselect MP3 SCI
LUI	R2, BitMask(LATG15_bit+0)
ORI	R2, R2, BitMask(LATG15_bit+0)
_SX	8, Offset(LATG15_bit+8), 4
;MP3_driver.c,137 :: 		while (DREQ == 0);             // wait until DREQ becomes 1, see MP3 codec datasheet, Serial Protocol for SCI
L_MP3_SCI_Read4:
_LX	, 4
EXT	R2, R2, BitPos(RD8_bit+0), 1
BEQ	R2, R0, L__MP3_SCI_Read71
NOP	
J	L_MP3_SCI_Read5
NOP	
L__MP3_SCI_Read71:
J	L_MP3_SCI_Read4
NOP	
L_MP3_SCI_Read5:
;MP3_driver.c,138 :: 		}
L_end_MP3_SCI_Read:
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _MP3_SCI_Read
_MP3_SDI_Write:
;MP3_driver.c,147 :: 		void MP3_SDI_Write(char data_) {
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;MP3_driver.c,149 :: 		MP3_CS = 1;
LUI	R2, BitMask(LATG15_bit+0)
ORI	R2, R2, BitMask(LATG15_bit+0)
_SX	8, Offset(LATG15_bit+8), 4
;MP3_driver.c,150 :: 		BSYNC = 0;
LUI	R2, BitMask(LATB8_bit+0)
ORI	R2, R2, BitMask(LATB8_bit+0)
_SX	8, Offset(LATB8_bit+4), 4
;MP3_driver.c,152 :: 		while (DREQ == 0);             // wait until DREQ becomes 1, see MP3 codec datasheet, Serial Protocol for SCI
L_MP3_SDI_Write6:
_LX	, 4
EXT	R2, R2, BitPos(RD8_bit+0), 1
BEQ	R2, R0, L__MP3_SDI_Write73
NOP	
J	L_MP3_SDI_Write7
NOP	
L__MP3_SDI_Write73:
J	L_MP3_SDI_Write6
NOP	
L_MP3_SDI_Write7:
;MP3_driver.c,154 :: 		SPI2_Write(data_);
ANDI	R25, R25, 255
JAL	_SPI2_Write+0
NOP	
;MP3_driver.c,155 :: 		BSYNC = 1;
LUI	R2, BitMask(LATB8_bit+0)
ORI	R2, R2, BitMask(LATB8_bit+0)
_SX	8, Offset(LATB8_bit+8), 4
;MP3_driver.c,156 :: 		}
L_end_MP3_SDI_Write:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _MP3_SDI_Write
_MP3_SDI_Write_32:
;MP3_driver.c,165 :: 		void MP3_SDI_Write_32(char *data_) {
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;MP3_driver.c,168 :: 		MP3_CS = 1;
LUI	R2, BitMask(LATG15_bit+0)
ORI	R2, R2, BitMask(LATG15_bit+0)
_SX	8, Offset(LATG15_bit+8), 4
;MP3_driver.c,169 :: 		BSYNC = 0;
LUI	R2, BitMask(LATB8_bit+0)
ORI	R2, R2, BitMask(LATB8_bit+0)
_SX	8, Offset(LATB8_bit+4), 4
;MP3_driver.c,171 :: 		while (DREQ == 0);             // wait until DREQ becomes 1, see MP3 codec datasheet, Serial Protocol for SCI
L_MP3_SDI_Write_328:
_LX	, 4
EXT	R2, R2, BitPos(RD8_bit+0), 1
BEQ	R2, R0, L__MP3_SDI_Write_3275
NOP	
J	L_MP3_SDI_Write_329
NOP	
L__MP3_SDI_Write_3275:
J	L_MP3_SDI_Write_328
NOP	
L_MP3_SDI_Write_329:
;MP3_driver.c,173 :: 		for (i=0; i<32; i++)
; i start address is: 12 (R3)
MOVZ	R3, R0, R0
; i end address is: 12 (R3)
L_MP3_SDI_Write_3210:
; i start address is: 12 (R3)
ANDI	R2, R3, 255
SLTIU	R2, R2, 32
BNE	R2, R0, L__MP3_SDI_Write_3276
NOP	
J	L_MP3_SDI_Write_3211
NOP	
L__MP3_SDI_Write_3276:
;MP3_driver.c,174 :: 		SPI2_Write(data_[i]);
ANDI	R2, R3, 255
ADDU	R2, R25, R2
SW	R25, 4(SP)
LBU	R25, 0(R2)
JAL	_SPI2_Write+0
NOP	
LW	R25, 4(SP)
;MP3_driver.c,173 :: 		for (i=0; i<32; i++)
ADDIU	R2, R3, 1
ANDI	R3, R2, 255
;MP3_driver.c,174 :: 		SPI2_Write(data_[i]);
; i end address is: 12 (R3)
J	L_MP3_SDI_Write_3210
NOP	
L_MP3_SDI_Write_3211:
;MP3_driver.c,175 :: 		BSYNC = 1;
LUI	R2, BitMask(LATB8_bit+0)
ORI	R2, R2, BitMask(LATB8_bit+0)
_SX	8, Offset(LATB8_bit+8), 4
;MP3_driver.c,176 :: 		}
L_end_MP3_SDI_Write_32:
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _MP3_SDI_Write_32
_MP3_Set_Volume:
;MP3_driver.c,185 :: 		void MP3_Set_Volume(char left, char right) {
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;MP3_driver.c,188 :: 		volume = (left<<8) + right;             // calculate value
SW	R25, 4(SP)
SW	R26, 8(SP)
ANDI	R2, R25, 255
SLL	R3, R2, 8
ANDI	R2, R26, 255
ADDU	R2, R3, R2
;MP3_driver.c,189 :: 		MP3_SCI_Write(SCI_VOL_ADDR, volume);    // Write value to VOL register
ANDI	R26, R2, 65535
ORI	R25, R0, 11
JAL	_MP3_SCI_Write+0
NOP	
;MP3_driver.c,190 :: 		}
L_end_MP3_Set_Volume:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _MP3_Set_Volume
_MP3_Init:
;MP3_driver.c,192 :: 		void MP3_Init(void)
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;MP3_driver.c,194 :: 		BSYNC = 1;
SW	R25, 4(SP)
SW	R26, 8(SP)
LUI	R2, BitMask(LATB8_bit+0)
ORI	R2, R2, BitMask(LATB8_bit+0)
_SX	8, Offset(LATB8_bit+8), 4
;MP3_driver.c,195 :: 		MP3_CS = 1;
LUI	R2, BitMask(LATG15_bit+0)
ORI	R2, R2, BitMask(LATG15_bit+0)
_SX	8, Offset(LATG15_bit+8), 4
;MP3_driver.c,198 :: 		MP3_RST = 0;
LUI	R2, BitMask(LATD9_bit+0)
ORI	R2, R2, BitMask(LATD9_bit+0)
_SX	8, Offset(LATD9_bit+4), 4
;MP3_driver.c,199 :: 		Delay_ms(10);
LUI	R24, 4
ORI	R24, R24, 4522
L_MP3_Init13:
ADDIU	R24, R24, -1
BNE	R24, R0, L_MP3_Init13
NOP	
;MP3_driver.c,200 :: 		MP3_RST = 1;
LUI	R2, BitMask(LATD9_bit+0)
ORI	R2, R2, BitMask(LATD9_bit+0)
_SX	8, Offset(LATD9_bit+8), 4
;MP3_driver.c,202 :: 		while (DREQ == 0);
L_MP3_Init15:
_LX	, 4
EXT	R2, R2, BitPos(RD8_bit+0), 1
BEQ	R2, R0, L__MP3_Init79
NOP	
J	L_MP3_Init16
NOP	
L__MP3_Init79:
J	L_MP3_Init15
NOP	
L_MP3_Init16:
;MP3_driver.c,204 :: 		MP3_SCI_Write(SCI_MODE_ADDR, 0x0800);
ORI	R26, R0, 2048
MOVZ	R25, R0, R0
JAL	_MP3_SCI_Write+0
NOP	
;MP3_driver.c,205 :: 		MP3_SCI_Write(SCI_BASS_ADDR, 0x7A00);
ORI	R26, R0, 31232
ORI	R25, R0, 2
JAL	_MP3_SCI_Write+0
NOP	
;MP3_driver.c,206 :: 		MP3_SCI_Write(SCI_CLOCKF_ADDR, 0x2000);   // default 12 288 000 Hz
ORI	R26, R0, 8192
ORI	R25, R0, 3
JAL	_MP3_SCI_Write+0
NOP	
;MP3_driver.c,209 :: 		volume_left  = 0x42; //0x3F;
ORI	R2, R0, 66
SB	R2, Offset(_volume_left+0)(GP)
;MP3_driver.c,210 :: 		volume_right = 0x42; //0x3F;
ORI	R2, R0, 66
SB	R2, Offset(_volume_right+0)(GP)
;MP3_driver.c,211 :: 		MP3_Set_Volume(volume_left, volume_right);
ORI	R26, R0, 66
ORI	R25, R0, 66
JAL	_MP3_Set_Volume+0
NOP	
;MP3_driver.c,213 :: 		MP3_CS = 0;
LUI	R2, BitMask(LATG15_bit+0)
ORI	R2, R2, BitMask(LATG15_bit+0)
_SX	8, Offset(LATG15_bit+4), 4
;MP3_driver.c,214 :: 		}
L_end_MP3_Init:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _MP3_Init
_MP3_Start:
;MP3_driver.c,223 :: 		void MP3_Start(void)
ADDIU	SP, SP, -20
SW	RA, 0(SP)
;MP3_driver.c,225 :: 		IC1CONbits.FEDGE = 1;           // Fronts montants
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
SW	R28, 16(SP)
ORI	R2, R0, 512
SW	R2, Offset(IC1CONbits+8)(GP)
;MP3_driver.c,226 :: 		IC1IP0_bit = 1;                 // interruptions de niveau 4
LUI	R2, BitMask(IC1IP0_bit+0)
ORI	R2, R2, BitMask(IC1IP0_bit+0)
_SX	8, Offset(IC1IP0_bit+8), 4
;MP3_driver.c,227 :: 		IC1IP1_bit = 1;
LUI	R2, BitMask(IC1IP1_bit+0)
ORI	R2, R2, BitMask(IC1IP1_bit+0)
_SX	8, Offset(IC1IP1_bit+8), 4
;MP3_driver.c,228 :: 		IC1IP2_bit = 1;
LUI	R2, BitMask(IC1IP2_bit+0)
ORI	R2, R2, BitMask(IC1IP2_bit+0)
_SX	8, Offset(IC1IP2_bit+8), 4
;MP3_driver.c,229 :: 		IC1CONSETbits.ICI = 0b00;
LBU	R2, Offset(IC1CONSETbits+0)(GP)
INS	R2, R0, 5, 2
SB	R2, Offset(IC1CONSETbits+0)(GP)
;MP3_driver.c,230 :: 		IC1CONSETbits.ICM = 0b001;
ORI	R3, R0, 1
LBU	R2, Offset(IC1CONSETbits+0)(GP)
INS	R2, R3, 0, 3
SB	R2, Offset(IC1CONSETbits+0)(GP)
;MP3_driver.c,231 :: 		IC1CONbits.ON = 1;
ORI	R2, R0, 32768
SW	R2, Offset(IC1CONbits+8)(GP)
;MP3_driver.c,232 :: 		IC1CONbits.SIDL = 0;
ORI	R2, R0, 8192
SW	R2, Offset(IC1CONbits+4)(GP)
;MP3_driver.c,233 :: 		IC1IE_bit = 1;                  // interruptions activees
LUI	R2, BitMask(IC1IE_bit+0)
ORI	R2, R2, BitMask(IC1IE_bit+0)
_SX	8, Offset(IC1IE_bit+8), 4
;MP3_driver.c,234 :: 		EnableInterrupts();
EI	R30
;MP3_driver.c,236 :: 		CS_Serial_Flash_Direction_bit = 0;
LUI	R2, BitMask(TRISC2_bit+0)
ORI	R2, R2, BitMask(TRISC2_bit+0)
_SX	8, Offset(TRISC2_bit+4), 4
;MP3_driver.c,237 :: 		CS_Serial_Flash_bit = 1;             // Disable Serial Flash module
LUI	R2, BitMask(LATC2_bit+0)
ORI	R2, R2, BitMask(LATC2_bit+0)
_SX	8, Offset(LATC2_bit+8), 4
;MP3_driver.c,239 :: 		MP3_CS_Direction  = 0;               // Configure MP3_CS as output
LUI	R2, BitMask(TRISG15_bit+0)
ORI	R2, R2, BitMask(TRISG15_bit+0)
_SX	8, Offset(TRISG15_bit+4), 4
;MP3_driver.c,240 :: 		MP3_CS            = 1;               // Deselect MP3_CS
LUI	R2, BitMask(LATG15_bit+0)
ORI	R2, R2, BitMask(LATG15_bit+0)
_SX	8, Offset(LATG15_bit+8), 4
;MP3_driver.c,241 :: 		MP3_RST_Direction = 0;               // Configure MP3_RST as output
LUI	R2, BitMask(TRISD9_bit+0)
ORI	R2, R2, BitMask(TRISD9_bit+0)
_SX	8, Offset(TRISD9_bit+4), 4
;MP3_driver.c,242 :: 		MP3_RST           = 1;               // Set MP3_RST pin
LUI	R2, BitMask(LATD9_bit+0)
ORI	R2, R2, BitMask(LATD9_bit+0)
_SX	8, Offset(LATD9_bit+8), 4
;MP3_driver.c,244 :: 		DREQ_Direction    = 1;               // Configure DREQ as input
LUI	R2, BitMask(TRISD8_bit+0)
ORI	R2, R2, BitMask(TRISD8_bit+0)
_SX	8, Offset(TRISD8_bit+8), 4
;MP3_driver.c,245 :: 		BSYNC_Direction   = 0;               // Configure BSYNC as output
LUI	R2, BitMask(TRISB8_bit+0)
ORI	R2, R2, BitMask(TRISB8_bit+0)
_SX	8, Offset(TRISB8_bit+4), 4
;MP3_driver.c,246 :: 		BSYNC             = 0;               // Clear BSYNC
LUI	R2, BitMask(LATB8_bit+0)
ORI	R2, R2, BitMask(LATB8_bit+0)
_SX	8, Offset(LATB8_bit+4), 4
;MP3_driver.c,247 :: 		BSYNC             = 1;               // Clear BSYNC
LUI	R2, BitMask(LATB8_bit+0)
ORI	R2, R2, BitMask(LATB8_bit+0)
_SX	8, Offset(LATB8_bit+8), 4
;MP3_driver.c,249 :: 		SPI2_Init_Advanced(_SPI_MASTER, _SPI_8_BIT, 26, _SPI_SS_DISABLE, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_IDLE_2_ACTIVE);
ORI	R2, R0, 256
MOVZ	R28, R0, R0
ORI	R27, R0, 26
MOVZ	R26, R0, R0
ORI	R25, R0, 32
ADDIU	SP, SP, -8
SH	R2, 4(SP)
SH	R0, 2(SP)
SH	R0, 0(SP)
JAL	_SPI2_Init_Advanced+0
NOP	
ADDIU	SP, SP, 8
;MP3_driver.c,251 :: 		MP3_Init();
JAL	_MP3_Init+0
NOP	
;MP3_driver.c,252 :: 		Delay_ms(1000);
LUI	R24, 406
ORI	R24, R24, 59050
L_MP3_Start17:
ADDIU	R24, R24, -1
BNE	R24, R0, L_MP3_Start17
NOP	
;MP3_driver.c,253 :: 		}
L_end_MP3_Start:
LW	R28, 16(SP)
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 20
JR	RA
NOP	
; end of _MP3_Start
_StartPlayingFile:
;MP3_driver.c,255 :: 		int StartPlayingFile(char * fileName)
ADDIU	SP, SP, -24
SW	RA, 0(SP)
;MP3_driver.c,257 :: 		int i = 0;
SW	R25, 4(SP)
SW	R26, 8(SP)
;MP3_driver.c,258 :: 		int position = 0;
;MP3_driver.c,259 :: 		int result = 0;
; result start address is: 16 (R4)
MOVZ	R4, R0, R0
;MP3_driver.c,260 :: 		if (FatType == 16) {
LH	R3, Offset(_FatType+0)(GP)
ORI	R2, R0, 16
BEQ	R3, R2, L__StartPlayingFile82
NOP	
J	L__StartPlayingFile59
NOP	
L__StartPlayingFile82:
; result end address is: 16 (R4)
;MP3_driver.c,261 :: 		result = Mmc_Fat_Assign(fileName, 0x01);
ORI	R26, R0, 1
JAL	_Mmc_Fat_Assign+0
NOP	
; result start address is: 12 (R3)
ANDI	R3, R2, 255
; result end address is: 12 (R3)
SEH	R2, R3
;MP3_driver.c,266 :: 		}  */
J	L_StartPlayingFile19
NOP	
L__StartPlayingFile59:
;MP3_driver.c,260 :: 		if (FatType == 16) {
SEH	R2, R4
;MP3_driver.c,266 :: 		}  */
L_StartPlayingFile19:
;MP3_driver.c,268 :: 		if (result == 1) {
; result start address is: 8 (R2)
SEH	R3, R2
; result end address is: 8 (R2)
ORI	R2, R0, 1
BEQ	R3, R2, L__StartPlayingFile83
NOP	
J	L_StartPlayingFile20
NOP	
L__StartPlayingFile83:
;MP3_driver.c,269 :: 		Mmc_Fat_Reset(&file_size);
LUI	R25, #hi_addr(_file_size+0)
ORI	R25, R25, #lo_addr(_file_size+0)
JAL	_Mmc_Fat_Reset+0
NOP	
;MP3_driver.c,270 :: 		total_file_size = file_size;
LW	R2, Offset(_file_size+0)(GP)
SW	R2, Offset(_total_file_size+0)(GP)
;MP3_driver.c,271 :: 		playing = 1;
ORI	R2, R0, 1
SH	R2, Offset(_playing+0)(GP)
;MP3_driver.c,272 :: 		while (DREQ == 1) {
L_StartPlayingFile21:
_LX	, 4
EXT	R2, R2, BitPos(RD8_bit+0), 1
BNE	R2, 1, L__StartPlayingFile85
NOP	
J	L_StartPlayingFile22
NOP	
L__StartPlayingFile85:
;MP3_driver.c,273 :: 		for (i=0; i<BYTES_2_WRITE; i++)
; i start address is: 16 (R4)
MOVZ	R4, R0, R0
; i end address is: 16 (R4)
L_StartPlayingFile23:
; i start address is: 16 (R4)
SEH	R2, R4
SLTI	R2, R2, 32
BNE	R2, R0, L__StartPlayingFile86
NOP	
J	L_StartPlayingFile24
NOP	
L__StartPlayingFile86:
;MP3_driver.c,276 :: 		else if (FatType == 32) FAT32_Read(fileHandler, mp3_buffer+i,1);   */
LH	R3, Offset(_FatType+0)(GP)
ORI	R2, R0, 16
BEQ	R3, R2, L__StartPlayingFile87
NOP	
J	L_StartPlayingFile26
NOP	
L__StartPlayingFile87:
SEH	R3, R4
LUI	R2, #hi_addr(_mp3_buffer+0)
ORI	R2, R2, #lo_addr(_mp3_buffer+0)
ADDU	R2, R2, R3
SH	R4, 12(SP)
SW	R25, 16(SP)
MOVZ	R25, R2, R0
JAL	_Mmc_Fat_Read+0
NOP	
LW	R25, 16(SP)
LH	R4, 12(SP)
L_StartPlayingFile26:
;MP3_driver.c,273 :: 		for (i=0; i<BYTES_2_WRITE; i++)
ADDIU	R2, R4, 1
SEH	R4, R2
;MP3_driver.c,277 :: 		}
; i end address is: 16 (R4)
J	L_StartPlayingFile23
NOP	
L_StartPlayingFile24:
;MP3_driver.c,278 :: 		file_size-=BYTES_2_WRITE;
LW	R2, Offset(_file_size+0)(GP)
ADDIU	R2, R2, -32
SW	R2, Offset(_file_size+0)(GP)
;MP3_driver.c,279 :: 		MP3_SDI_Write_32(mp3_buffer);
SW	R25, 12(SP)
LUI	R25, #hi_addr(_mp3_buffer+0)
ORI	R25, R25, #lo_addr(_mp3_buffer+0)
JAL	_MP3_SDI_Write_32+0
NOP	
LW	R25, 12(SP)
;MP3_driver.c,280 :: 		}
J	L_StartPlayingFile21
NOP	
L_StartPlayingFile22:
;MP3_driver.c,281 :: 		position = (total_file_size - file_size) * 100 / total_file_size;
LW	R3, Offset(_file_size+0)(GP)
LW	R2, Offset(_total_file_size+0)(GP)
SUBU	R3, R2, R3
ORI	R2, R0, 100
MULTU	R3, R2
MFLO	R3
LW	R2, Offset(_total_file_size+0)(GP)
DIVU	R3, R2
MFLO	R2
; position start address is: 16 (R4)
MOVZ	R4, R2, R0
;MP3_driver.c,282 :: 		if (ProgressBar1.position != position) {
SEH	R3, R2
LHU	R2, Offset(_ProgressBar1+44)(GP)
BNE	R2, R3, L__StartPlayingFile89
NOP	
J	L_StartPlayingFile27
NOP	
L__StartPlayingFile89:
;MP3_driver.c,283 :: 		ProgressBar1.position = position;
SH	R4, Offset(_ProgressBar1+44)(GP)
;MP3_driver.c,284 :: 		ProgressButton.Left = ProgressBar1.Left + ProgressBar1.position/100.0 * ProgressBar1.Width - ProgressButton.Width/2;
ANDI	R4, R4, 65535
JAL	__Unsigned16IntToFloat+0
NOP	
; position end address is: 16 (R4)
LUI	R6, 17096
ORI	R6, R6, 0
MOVZ	R4, R2, R0
JAL	__Div_FP+0
NOP	
SW	R2, 20(SP)
LHU	R4, Offset(_ProgressBar1+10)(GP)
JAL	__Unsigned16IntToFloat+0
NOP	
LW	R4, 20(SP)
MOVZ	R6, R2, R0
JAL	__Mul_FP+0
NOP	
SW	R2, 20(SP)
LHU	R4, Offset(_ProgressBar1+6)(GP)
JAL	__Unsigned16IntToFloat+0
NOP	
LW	R4, 20(SP)
MOVZ	R6, R2, R0
JAL	__Add_FP+0
NOP	
SW	R2, 20(SP)
LHU	R2, Offset(_ProgressButton+10)(GP)
SRL	R2, R2, 1
ANDI	R4, R2, 65535
JAL	__Unsigned16IntToFloat+0
NOP	
LW	R4, 20(SP)
MOVZ	R6, R2, R0
JAL	__Sub_FP+0
NOP	
MOVZ	R4, R2, R0
JAL	__FloatToUnsignedIntegral+0
NOP	
SH	R2, Offset(_ProgressButton+6)(GP)
;MP3_driver.c,285 :: 		DrawBox(&ProgressMasque);
SW	R25, 12(SP)
LUI	R25, #hi_addr(_ProgressMasque+0)
ORI	R25, R25, #lo_addr(_ProgressMasque+0)
JAL	_DrawBox+0
NOP	
;MP3_driver.c,286 :: 		DrawProgressBar(&ProgressBar1);
LUI	R25, #hi_addr(_ProgressBar1+0)
ORI	R25, R25, #lo_addr(_ProgressBar1+0)
JAL	_DrawProgressBar+0
NOP	
;MP3_driver.c,287 :: 		DrawRoundBox(&ProgressButton);
LUI	R25, #hi_addr(_ProgressButton+0)
ORI	R25, R25, #lo_addr(_ProgressButton+0)
JAL	_DrawRoundBox+0
NOP	
LW	R25, 12(SP)
;MP3_driver.c,288 :: 		}
L_StartPlayingFile27:
;MP3_driver.c,289 :: 		return 0;
MOVZ	R2, R0, R0
J	L_end_StartPlayingFile
NOP	
;MP3_driver.c,290 :: 		}
L_StartPlayingFile20:
;MP3_driver.c,291 :: 		else return -1;
ORI	R2, R0, 65535
;MP3_driver.c,292 :: 		}
;MP3_driver.c,291 :: 		else return -1;
;MP3_driver.c,292 :: 		}
L_end_StartPlayingFile:
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 24
JR	RA
NOP	
; end of _StartPlayingFile
_ContinuePlaying:
;MP3_driver.c,294 :: 		void ContinuePlaying() {
ADDIU	SP, SP, -16
SW	RA, 0(SP)
;MP3_driver.c,295 :: 		int i = 0;
SW	R25, 4(SP)
;MP3_driver.c,296 :: 		int position = 0;
;MP3_driver.c,297 :: 		playing = 0;
SH	R0, Offset(_playing+0)(GP)
;MP3_driver.c,298 :: 		while(DREQ == 0);
L_ContinuePlaying29:
_LX	, 4
EXT	R2, R2, BitPos(RD8_bit+0), 1
BEQ	R2, R0, L__ContinuePlaying91
NOP	
J	L_ContinuePlaying30
NOP	
L__ContinuePlaying91:
J	L_ContinuePlaying29
NOP	
L_ContinuePlaying30:
;MP3_driver.c,299 :: 		while ((DREQ == 1) && (file_size >= BYTES_2_WRITE)) {
L_ContinuePlaying31:
_LX	, 4
EXT	R2, R2, BitPos(RD8_bit+0), 1
BNE	R2, 1, L__ContinuePlaying93
NOP	
J	L__ContinuePlaying62
NOP	
L__ContinuePlaying93:
LW	R2, Offset(_file_size+0)(GP)
SLTIU	R2, R2, 32
BEQ	R2, R0, L__ContinuePlaying94
NOP	
J	L__ContinuePlaying61
NOP	
L__ContinuePlaying94:
L__ContinuePlaying60:
;MP3_driver.c,300 :: 		for (i=0; i<BYTES_2_WRITE; i++)
; i start address is: 16 (R4)
MOVZ	R4, R0, R0
; i end address is: 16 (R4)
L_ContinuePlaying35:
; i start address is: 16 (R4)
SEH	R2, R4
SLTI	R2, R2, 32
BNE	R2, R0, L__ContinuePlaying95
NOP	
J	L_ContinuePlaying36
NOP	
L__ContinuePlaying95:
;MP3_driver.c,303 :: 		else if (FatType == 32) FAT32_Read(fileHandler, mp3_buffer+i,1);  */
LH	R3, Offset(_FatType+0)(GP)
ORI	R2, R0, 16
BEQ	R3, R2, L__ContinuePlaying96
NOP	
J	L_ContinuePlaying38
NOP	
L__ContinuePlaying96:
SEH	R3, R4
LUI	R2, #hi_addr(_mp3_buffer+0)
ORI	R2, R2, #lo_addr(_mp3_buffer+0)
ADDU	R2, R2, R3
SH	R4, 8(SP)
MOVZ	R25, R2, R0
JAL	_Mmc_Fat_Read+0
NOP	
LH	R4, 8(SP)
L_ContinuePlaying38:
;MP3_driver.c,300 :: 		for (i=0; i<BYTES_2_WRITE; i++)
ADDIU	R2, R4, 1
SEH	R4, R2
;MP3_driver.c,304 :: 		}
; i end address is: 16 (R4)
J	L_ContinuePlaying35
NOP	
L_ContinuePlaying36:
;MP3_driver.c,305 :: 		file_size-=BYTES_2_WRITE;
LW	R2, Offset(_file_size+0)(GP)
ADDIU	R2, R2, -32
SW	R2, Offset(_file_size+0)(GP)
;MP3_driver.c,306 :: 		MP3_SDI_Write_32(mp3_buffer);
LUI	R25, #hi_addr(_mp3_buffer+0)
ORI	R25, R25, #lo_addr(_mp3_buffer+0)
JAL	_MP3_SDI_Write_32+0
NOP	
;MP3_driver.c,307 :: 		}
J	L_ContinuePlaying31
NOP	
;MP3_driver.c,299 :: 		while ((DREQ == 1) && (file_size >= BYTES_2_WRITE)) {
L__ContinuePlaying62:
L__ContinuePlaying61:
;MP3_driver.c,308 :: 		playing = 1;
ORI	R2, R0, 1
SH	R2, Offset(_playing+0)(GP)
;MP3_driver.c,309 :: 		position = (total_file_size - file_size) * 100 / total_file_size;
LW	R3, Offset(_file_size+0)(GP)
LW	R2, Offset(_total_file_size+0)(GP)
SUBU	R3, R2, R3
ORI	R2, R0, 100
MULTU	R3, R2
MFLO	R3
LW	R2, Offset(_total_file_size+0)(GP)
DIVU	R3, R2
MFLO	R2
; position start address is: 16 (R4)
MOVZ	R4, R2, R0
;MP3_driver.c,310 :: 		if (ProgressBar1.position != position) {
SEH	R3, R2
LHU	R2, Offset(_ProgressBar1+44)(GP)
BNE	R2, R3, L__ContinuePlaying98
NOP	
J	L_ContinuePlaying39
NOP	
L__ContinuePlaying98:
;MP3_driver.c,311 :: 		ProgressBar1.position = position;
SH	R4, Offset(_ProgressBar1+44)(GP)
;MP3_driver.c,312 :: 		ProgressButton.Left = ProgressBar1.Left + ProgressBar1.position/100.0 * ProgressBar1.Width - ProgressButton.Width/2;
ANDI	R4, R4, 65535
JAL	__Unsigned16IntToFloat+0
NOP	
; position end address is: 16 (R4)
LUI	R6, 17096
ORI	R6, R6, 0
MOVZ	R4, R2, R0
JAL	__Div_FP+0
NOP	
SW	R2, 12(SP)
LHU	R4, Offset(_ProgressBar1+10)(GP)
JAL	__Unsigned16IntToFloat+0
NOP	
LW	R4, 12(SP)
MOVZ	R6, R2, R0
JAL	__Mul_FP+0
NOP	
SW	R2, 12(SP)
LHU	R4, Offset(_ProgressBar1+6)(GP)
JAL	__Unsigned16IntToFloat+0
NOP	
LW	R4, 12(SP)
MOVZ	R6, R2, R0
JAL	__Add_FP+0
NOP	
SW	R2, 12(SP)
LHU	R2, Offset(_ProgressButton+10)(GP)
SRL	R2, R2, 1
ANDI	R4, R2, 65535
JAL	__Unsigned16IntToFloat+0
NOP	
LW	R4, 12(SP)
MOVZ	R6, R2, R0
JAL	__Sub_FP+0
NOP	
MOVZ	R4, R2, R0
JAL	__FloatToUnsignedIntegral+0
NOP	
SH	R2, Offset(_ProgressButton+6)(GP)
;MP3_driver.c,313 :: 		DrawBox(&ProgressMasque);
LUI	R25, #hi_addr(_ProgressMasque+0)
ORI	R25, R25, #lo_addr(_ProgressMasque+0)
JAL	_DrawBox+0
NOP	
;MP3_driver.c,314 :: 		DrawProgressBar(&ProgressBar1);
LUI	R25, #hi_addr(_ProgressBar1+0)
ORI	R25, R25, #lo_addr(_ProgressBar1+0)
JAL	_DrawProgressBar+0
NOP	
;MP3_driver.c,315 :: 		DrawRoundBox(&ProgressButton);
LUI	R25, #hi_addr(_ProgressButton+0)
ORI	R25, R25, #lo_addr(_ProgressButton+0)
JAL	_DrawRoundBox+0
NOP	
;MP3_driver.c,316 :: 		}
L_ContinuePlaying39:
;MP3_driver.c,317 :: 		}
L_end_ContinuePlaying:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 16
JR	RA
NOP	
; end of _ContinuePlaying
_ChangePosition:
;MP3_driver.c,319 :: 		void ChangePosition(unsigned long position)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;MP3_driver.c,322 :: 		else if(FatType == 32) FAT32_Seek(fileHandler, position); */
LH	R3, Offset(_FatType+0)(GP)
ORI	R2, R0, 16
BEQ	R3, R2, L__ChangePosition100
NOP	
J	L_ChangePosition40
NOP	
L__ChangePosition100:
JAL	_Mmc_Fat_Seek+0
NOP	
L_ChangePosition40:
;MP3_driver.c,323 :: 		}
L_end_ChangePosition:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _ChangePosition
_IC1_ISR:
;MP3_driver.c,325 :: 		void IC1_ISR() iv IVT_INPUT_CAPTURE_1 ilevel 7 ics ICS_SRS {
RDPGPR	SP, SP
ADDIU	SP, SP, -12
MFC0	R30, 12, 2
SW	R30, 8(SP)
MFC0	R30, 14, 0
SW	R30, 4(SP)
MFC0	R30, 12, 0
SW	R30, 0(SP)
INS	R30, R0, 1, 15
ORI	R30, R0, 7168
MTC0	R30, 12, 0
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;MP3_driver.c,326 :: 		long buff = 0;
;MP3_driver.c,327 :: 		int i = 0;
;MP3_driver.c,328 :: 		int position = 0;
;MP3_driver.c,329 :: 		if (playing == 1) {
LH	R3, Offset(_playing+0)(GP)
ORI	R2, R0, 1
BEQ	R3, R2, L__IC1_ISR102
NOP	
J	L_IC1_ISR41
NOP	
L__IC1_ISR102:
;MP3_driver.c,330 :: 		while ((DREQ == 1) && (file_size >= BYTES_2_WRITE)) {
L_IC1_ISR42:
_LX	, 4
EXT	R2, R2, BitPos(RD8_bit+0), 1
BNE	R2, 1, L__IC1_ISR104
NOP	
J	L__IC1_ISR65
NOP	
L__IC1_ISR104:
LW	R2, Offset(_file_size+0)(GP)
SLTIU	R2, R2, 32
BEQ	R2, R0, L__IC1_ISR105
NOP	
J	L__IC1_ISR64
NOP	
L__IC1_ISR105:
L__IC1_ISR63:
;MP3_driver.c,331 :: 		for (i=0; i<BYTES_2_WRITE; i++)
; i start address is: 16 (R4)
MOVZ	R4, R0, R0
; i end address is: 16 (R4)
L_IC1_ISR46:
; i start address is: 16 (R4)
SEH	R2, R4
SLTI	R2, R2, 32
BNE	R2, R0, L__IC1_ISR106
NOP	
J	L_IC1_ISR47
NOP	
L__IC1_ISR106:
;MP3_driver.c,334 :: 		else if (FatType == 32) FAT32_Read(fileHandler, mp3_buffer+i,1);   */
LH	R3, Offset(_FatType+0)(GP)
ORI	R2, R0, 16
BEQ	R3, R2, L__IC1_ISR107
NOP	
J	L_IC1_ISR49
NOP	
L__IC1_ISR107:
SEH	R3, R4
LUI	R2, #hi_addr(_mp3_buffer+0)
ORI	R2, R2, #lo_addr(_mp3_buffer+0)
ADDU	R2, R2, R3
SH	R4, 4(SP)
MOVZ	R25, R2, R0
JAL	_Mmc_Fat_Read+0
NOP	
LH	R4, 4(SP)
L_IC1_ISR49:
;MP3_driver.c,331 :: 		for (i=0; i<BYTES_2_WRITE; i++)
ADDIU	R2, R4, 1
SEH	R4, R2
;MP3_driver.c,335 :: 		}
; i end address is: 16 (R4)
J	L_IC1_ISR46
NOP	
L_IC1_ISR47:
;MP3_driver.c,336 :: 		file_size-=BYTES_2_WRITE;
LW	R2, Offset(_file_size+0)(GP)
ADDIU	R2, R2, -32
SW	R2, Offset(_file_size+0)(GP)
;MP3_driver.c,337 :: 		MP3_SDI_Write_32(mp3_buffer);
LUI	R25, #hi_addr(_mp3_buffer+0)
ORI	R25, R25, #lo_addr(_mp3_buffer+0)
JAL	_MP3_SDI_Write_32+0
NOP	
;MP3_driver.c,338 :: 		}
J	L_IC1_ISR42
NOP	
;MP3_driver.c,330 :: 		while ((DREQ == 1) && (file_size >= BYTES_2_WRITE)) {
L__IC1_ISR65:
L__IC1_ISR64:
;MP3_driver.c,339 :: 		if (file_size < BYTES_2_WRITE) {
LW	R2, Offset(_file_size+0)(GP)
SLTIU	R2, R2, 32
BNE	R2, R0, L__IC1_ISR108
NOP	
J	L_IC1_ISR50
NOP	
L__IC1_ISR108:
;MP3_driver.c,340 :: 		for (i=0; i<file_size; i++)
; i start address is: 16 (R4)
MOVZ	R4, R0, R0
; i end address is: 16 (R4)
L_IC1_ISR51:
; i start address is: 16 (R4)
SEH	R3, R4
LW	R2, Offset(_file_size+0)(GP)
SLTU	R2, R3, R2
BNE	R2, R0, L__IC1_ISR109
NOP	
J	L_IC1_ISR52
NOP	
L__IC1_ISR109:
;MP3_driver.c,343 :: 		else if (FatType == 32) FAT32_Read(fileHandler, mp3_buffer+i,1);   */
LH	R3, Offset(_FatType+0)(GP)
ORI	R2, R0, 16
BEQ	R3, R2, L__IC1_ISR110
NOP	
J	L_IC1_ISR54
NOP	
L__IC1_ISR110:
SEH	R3, R4
LUI	R2, #hi_addr(_mp3_buffer+0)
ORI	R2, R2, #lo_addr(_mp3_buffer+0)
ADDU	R2, R2, R3
SH	R4, 4(SP)
MOVZ	R25, R2, R0
JAL	_Mmc_Fat_Read+0
NOP	
LH	R4, 4(SP)
L_IC1_ISR54:
;MP3_driver.c,340 :: 		for (i=0; i<file_size; i++)
ADDIU	R2, R4, 1
SEH	R4, R2
;MP3_driver.c,344 :: 		}
; i end address is: 16 (R4)
J	L_IC1_ISR51
NOP	
L_IC1_ISR52:
;MP3_driver.c,345 :: 		for (i=0; i<file_size; i++)
; i start address is: 16 (R4)
MOVZ	R4, R0, R0
; i end address is: 16 (R4)
L_IC1_ISR55:
; i start address is: 16 (R4)
SEH	R3, R4
LW	R2, Offset(_file_size+0)(GP)
SLTU	R2, R3, R2
BNE	R2, R0, L__IC1_ISR111
NOP	
J	L_IC1_ISR56
NOP	
L__IC1_ISR111:
;MP3_driver.c,347 :: 		MP3_SDI_Write(mp3_buffer+i);
SEH	R3, R4
LUI	R2, #hi_addr(_mp3_buffer+0)
ORI	R2, R2, #lo_addr(_mp3_buffer+0)
ADDU	R2, R2, R3
MOVZ	R25, R2, R0
JAL	_MP3_SDI_Write+0
NOP	
;MP3_driver.c,345 :: 		for (i=0; i<file_size; i++)
ADDIU	R2, R4, 1
SEH	R4, R2
;MP3_driver.c,348 :: 		}
; i end address is: 16 (R4)
J	L_IC1_ISR55
NOP	
L_IC1_ISR56:
;MP3_driver.c,349 :: 		playing = 0;
SH	R0, Offset(_playing+0)(GP)
;MP3_driver.c,350 :: 		}
L_IC1_ISR50:
;MP3_driver.c,351 :: 		position = (total_file_size - file_size) * 100 / total_file_size;
LW	R3, Offset(_file_size+0)(GP)
LW	R2, Offset(_total_file_size+0)(GP)
SUBU	R3, R2, R3
ORI	R2, R0, 100
MULTU	R3, R2
MFLO	R3
LW	R2, Offset(_total_file_size+0)(GP)
DIVU	R3, R2
MFLO	R2
; position start address is: 16 (R4)
MOVZ	R4, R2, R0
;MP3_driver.c,352 :: 		if (ProgressBar1.position != position) {
SEH	R3, R2
LHU	R2, Offset(_ProgressBar1+44)(GP)
BNE	R2, R3, L__IC1_ISR113
NOP	
J	L_IC1_ISR58
NOP	
L__IC1_ISR113:
;MP3_driver.c,353 :: 		ProgressBar1.position = position;
SH	R4, Offset(_ProgressBar1+44)(GP)
;MP3_driver.c,354 :: 		ProgressButton.Left = ProgressBar1.Left + ProgressBar1.position/100.0 * ProgressBar1.Width - ProgressButton.Width/2;
ANDI	R4, R4, 65535
JAL	__Unsigned16IntToFloat+0
NOP	
; position end address is: 16 (R4)
LUI	R6, 17096
ORI	R6, R6, 0
MOVZ	R4, R2, R0
JAL	__Div_FP+0
NOP	
SW	R2, 8(SP)
LHU	R4, Offset(_ProgressBar1+10)(GP)
JAL	__Unsigned16IntToFloat+0
NOP	
LW	R4, 8(SP)
MOVZ	R6, R2, R0
JAL	__Mul_FP+0
NOP	
SW	R2, 8(SP)
LHU	R4, Offset(_ProgressBar1+6)(GP)
JAL	__Unsigned16IntToFloat+0
NOP	
LW	R4, 8(SP)
MOVZ	R6, R2, R0
JAL	__Add_FP+0
NOP	
SW	R2, 8(SP)
LHU	R2, Offset(_ProgressButton+10)(GP)
SRL	R2, R2, 1
ANDI	R4, R2, 65535
JAL	__Unsigned16IntToFloat+0
NOP	
LW	R4, 8(SP)
MOVZ	R6, R2, R0
JAL	__Sub_FP+0
NOP	
MOVZ	R4, R2, R0
JAL	__FloatToUnsignedIntegral+0
NOP	
SH	R2, Offset(_ProgressButton+6)(GP)
;MP3_driver.c,355 :: 		DrawBox(&ProgressMasque);
LUI	R25, #hi_addr(_ProgressMasque+0)
ORI	R25, R25, #lo_addr(_ProgressMasque+0)
JAL	_DrawBox+0
NOP	
;MP3_driver.c,356 :: 		DrawProgressBar(&ProgressBar1);
LUI	R25, #hi_addr(_ProgressBar1+0)
ORI	R25, R25, #lo_addr(_ProgressBar1+0)
JAL	_DrawProgressBar+0
NOP	
;MP3_driver.c,357 :: 		DrawRoundBox(&ProgressButton);
LUI	R25, #hi_addr(_ProgressButton+0)
ORI	R25, R25, #lo_addr(_ProgressButton+0)
JAL	_DrawRoundBox+0
NOP	
;MP3_driver.c,358 :: 		}
L_IC1_ISR58:
;MP3_driver.c,359 :: 		}
L_IC1_ISR41:
;MP3_driver.c,361 :: 		IC1IF_bit = 0;
LUI	R2, BitMask(IC1IF_bit+0)
ORI	R2, R2, BitMask(IC1IF_bit+0)
_SX	8, Offset(IC1IF_bit+4), 4
;MP3_driver.c,362 :: 		}
L_end_IC1_ISR:
LW	RA, 0(SP)
ADDIU	SP, SP, 12
DI	
EHB	
LW	R30, 8(SP)
MTC0	R30, 12, 2
LW	R30, 4(SP)
MTC0	R30, 14, 0
LW	R30, 0(SP)
MTC0	R30, 12, 0
ADDIU	SP, SP, 12
WRPGPR	SP, SP
ERET	
; end of _IC1_ISR
