_FAT32_Dev_Init:
;__Lib_FAT32_Driver.c,25 :: 		int8 FAT32_Dev_Init(void)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;__Lib_FAT32_Driver.c,27 :: 		if (OK != Mmc_Init())
JAL	_Mmc_Init+0
NOP	
ANDI	R2, R2, 65535
BNE	R2, R0, L__FAT32_Dev_Init11
NOP	
J	L_FAT32_Dev_Init0
NOP	
L__FAT32_Dev_Init11:
;__Lib_FAT32_Driver.c,29 :: 		return ERROR;
ORI	R2, R0, 255
J	L_end_FAT32_Dev_Init
NOP	
;__Lib_FAT32_Driver.c,30 :: 		}
L_FAT32_Dev_Init0:
;__Lib_FAT32_Driver.c,31 :: 		return OK;
MOVZ	R2, R0, R0
;__Lib_FAT32_Driver.c,32 :: 		}
L_end_FAT32_Dev_Init:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _FAT32_Dev_Init
_FAT32_Dev_Read_Sector:
;__Lib_FAT32_Driver.c,44 :: 		int8 FAT32_Dev_Read_Sector(__SECTOR sc, char* buf)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;__Lib_FAT32_Driver.c,46 :: 		if (Mmc_Read_Sector(sc, buf) != OK)
JAL	_Mmc_Read_Sector+0
NOP	
ANDI	R2, R2, 65535
BNE	R2, R0, L__FAT32_Dev_Read_Sector14
NOP	
J	L_FAT32_Dev_Read_Sector1
NOP	
L__FAT32_Dev_Read_Sector14:
;__Lib_FAT32_Driver.c,48 :: 		return ERROR;
ORI	R2, R0, 255
J	L_end_FAT32_Dev_Read_Sector
NOP	
;__Lib_FAT32_Driver.c,49 :: 		}
L_FAT32_Dev_Read_Sector1:
;__Lib_FAT32_Driver.c,50 :: 		return OK;
MOVZ	R2, R0, R0
;__Lib_FAT32_Driver.c,51 :: 		}
L_end_FAT32_Dev_Read_Sector:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _FAT32_Dev_Read_Sector
_FAT32_Dev_Write_Sector:
;__Lib_FAT32_Driver.c,63 :: 		int8 FAT32_Dev_Write_Sector(__SECTOR sc, char* buf)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;__Lib_FAT32_Driver.c,65 :: 		if (Mmc_Write_Sector(sc, buf) != OK)
JAL	_Mmc_Write_Sector+0
NOP	
ANDI	R2, R2, 65535
BNE	R2, R0, L__FAT32_Dev_Write_Sector17
NOP	
J	L_FAT32_Dev_Write_Sector2
NOP	
L__FAT32_Dev_Write_Sector17:
;__Lib_FAT32_Driver.c,67 :: 		return ERROR;
ORI	R2, R0, 255
J	L_end_FAT32_Dev_Write_Sector
NOP	
;__Lib_FAT32_Driver.c,68 :: 		}
L_FAT32_Dev_Write_Sector2:
;__Lib_FAT32_Driver.c,69 :: 		return OK;
MOVZ	R2, R0, R0
;__Lib_FAT32_Driver.c,70 :: 		}
L_end_FAT32_Dev_Write_Sector:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _FAT32_Dev_Write_Sector
_FAT32_Dev_SectorCount:
;__Lib_FAT32_Driver.c,84 :: 		int8 FAT32_Dev_SectorCount(uint32 *scCnt)
ADDIU	SP, SP, -24
SW	RA, 0(SP)
;__Lib_FAT32_Driver.c,92 :: 		if (Mmc_Read_Csd(csdbuf) != OK)
ADDIU	R2, SP, 8
SW	R25, 4(SP)
MOVZ	R25, R2, R0
JAL	_Mmc_Read_Csd+0
NOP	
LW	R25, 4(SP)
ANDI	R2, R2, 65535
BNE	R2, R0, L__FAT32_Dev_SectorCount20
NOP	
J	L_FAT32_Dev_SectorCount3
NOP	
L__FAT32_Dev_SectorCount20:
;__Lib_FAT32_Driver.c,94 :: 		return ERROR;
ORI	R2, R0, 255
J	L_end_FAT32_Dev_SectorCount
NOP	
;__Lib_FAT32_Driver.c,95 :: 		}
L_FAT32_Dev_SectorCount3:
;__Lib_FAT32_Driver.c,98 :: 		if (1 == ((csdbuf[0] & 0xC0) >> 6))
ADDIU	R2, SP, 8
LBU	R2, 0(R2)
ANDI	R2, R2, 192
ANDI	R2, R2, 255
SRL	R2, R2, 6
ANDI	R3, R2, 255
ORI	R2, R0, 1
BEQ	R3, R2, L__FAT32_Dev_SectorCount21
NOP	
J	L_FAT32_Dev_SectorCount4
NOP	
L__FAT32_Dev_SectorCount21:
;__Lib_FAT32_Driver.c,100 :: 		size  = 0;                  size <<= 8;
; size start address is: 8 (R2)
MOVZ	R2, R0, R0
SLL	R3, R2, 8
; size end address is: 8 (R2)
;__Lib_FAT32_Driver.c,101 :: 		size += csdbuf[7] & 0x3F;   size <<= 8;
ADDIU	R4, SP, 8
ADDIU	R2, R4, 7
LBU	R2, 0(R2)
ANDI	R2, R2, 63
ANDI	R2, R2, 255
ADDU	R2, R3, R2
SLL	R3, R2, 8
;__Lib_FAT32_Driver.c,102 :: 		size += csdbuf[8];          size <<= 8;
ADDIU	R2, R4, 8
LBU	R2, 0(R2)
ANDI	R2, R2, 255
ADDU	R2, R3, R2
SLL	R3, R2, 8
;__Lib_FAT32_Driver.c,103 :: 		size += csdbuf[9];          size <<= 0;
ADDIU	R2, R4, 9
LBU	R2, 0(R2)
ANDI	R2, R2, 255
ADDU	R2, R3, R2
;__Lib_FAT32_Driver.c,106 :: 		size *= 1024;
SLL	R2, R2, 10
; size start address is: 8 (R2)
;__Lib_FAT32_Driver.c,107 :: 		}
; size end address is: 8 (R2)
J	L_FAT32_Dev_SectorCount5
NOP	
L_FAT32_Dev_SectorCount4:
;__Lib_FAT32_Driver.c,111 :: 		c_size      = ((csdbuf[8] & 0xC0) >> 6) +
ADDIU	R6, SP, 8
ADDIU	R2, R6, 8
LBU	R2, 0(R2)
ANDI	R2, R2, 192
ANDI	R2, R2, 255
SRL	R4, R2, 6
;__Lib_FAT32_Driver.c,112 :: 		((unsigned) csdbuf[7] << 2) +
ADDIU	R2, R6, 7
LBU	R2, 0(R2)
ANDI	R2, R2, 255
ANDI	R2, R2, 65535
SLL	R3, R2, 2
ANDI	R2, R4, 255
ADDU	R3, R2, R3
;__Lib_FAT32_Driver.c,113 :: 		(((unsigned) csdbuf[6] & 0x03) << 10);
ADDIU	R2, R6, 6
LBU	R2, 0(R2)
ANDI	R2, R2, 255
ANDI	R2, R2, 3
ANDI	R2, R2, 65535
SLL	R2, R2, 10
ADDU	R5, R3, R2
;__Lib_FAT32_Driver.c,114 :: 		c_size_mult = (csdbuf[10] & 0x80) +
ADDIU	R2, R6, 10
LBU	R2, 0(R2)
ANDI	R4, R2, 128
;__Lib_FAT32_Driver.c,115 :: 		(((unsigned) csdbuf[9] & 0x03) << 8);
ADDIU	R2, R6, 9
LBU	R2, 0(R2)
ANDI	R2, R2, 255
ANDI	R2, R2, 3
ANDI	R2, R2, 65535
SLL	R3, R2, 8
ANDI	R2, R4, 255
ADDU	R2, R2, R3
;__Lib_FAT32_Driver.c,116 :: 		c_size_mult = c_size_mult >> 7;
ANDI	R2, R2, 65535
SRL	R3, R2, 7
;__Lib_FAT32_Driver.c,118 :: 		read_bl_len = csdbuf[5] & 0x0f;
ADDIU	R2, R6, 5
LBU	R2, 0(R2)
ANDI	R2, R2, 15
; read_bl_len start address is: 24 (R6)
ANDI	R6, R2, 255
;__Lib_FAT32_Driver.c,120 :: 		mult = 1;
; mult start address is: 16 (R4)
ORI	R4, R0, 1
;__Lib_FAT32_Driver.c,121 :: 		mult = mult << (c_size_mult + 2);
ADDIU	R2, R3, 2
ANDI	R3, R4, 65535
; mult end address is: 16 (R4)
ANDI	R2, R2, 65535
SLLV	R3, R3, R2
;__Lib_FAT32_Driver.c,123 :: 		blocknr = (c_size + 1) * (long) mult;
ADDIU	R2, R5, 1
ANDI	R3, R3, 65535
ANDI	R2, R2, 65535
MUL	R4, R2, R3
;__Lib_FAT32_Driver.c,124 :: 		block_len = 1;
; block_len start address is: 8 (R2)
ORI	R2, R0, 1
;__Lib_FAT32_Driver.c,125 :: 		block_len = block_len << read_bl_len;
ANDI	R3, R2, 65535
; block_len end address is: 8 (R2)
ANDI	R2, R6, 65535
; read_bl_len end address is: 24 (R6)
SLLV	R2, R3, R2
;__Lib_FAT32_Driver.c,127 :: 		size = block_len * blocknr;
ANDI	R2, R2, 65535
MULTU	R2, R4
MFLO	R2
;__Lib_FAT32_Driver.c,130 :: 		size /= 512;
SRL	R2, R2, 9
; size start address is: 12 (R3)
MOVZ	R3, R2, R0
; size end address is: 12 (R3)
MOVZ	R2, R3, R0
;__Lib_FAT32_Driver.c,131 :: 		}
L_FAT32_Dev_SectorCount5:
;__Lib_FAT32_Driver.c,133 :: 		*scCnt = size;
; size start address is: 8 (R2)
SW	R2, 0(R25)
; size end address is: 8 (R2)
;__Lib_FAT32_Driver.c,135 :: 		return OK;
MOVZ	R2, R0, R0
;__Lib_FAT32_Driver.c,136 :: 		}
L_end_FAT32_Dev_SectorCount:
LW	RA, 0(SP)
ADDIU	SP, SP, 24
JR	RA
NOP	
; end of _FAT32_Dev_SectorCount
_FAT32_Dev_Multi_Read_Start:
;__Lib_FAT32_Driver.c,166 :: 		int8 FAT32_Dev_Multi_Read_Start(__SECTOR sc)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;__Lib_FAT32_Driver.c,168 :: 		if (Mmc_Multi_Read_Start(sc) != OK)
JAL	_Mmc_Multi_Read_Start+0
NOP	
ANDI	R2, R2, 65535
BNE	R2, R0, L__FAT32_Dev_Multi_Read_Start24
NOP	
J	L_FAT32_Dev_Multi_Read_Start6
NOP	
L__FAT32_Dev_Multi_Read_Start24:
;__Lib_FAT32_Driver.c,170 :: 		return ERROR;
ORI	R2, R0, 255
J	L_end_FAT32_Dev_Multi_Read_Start
NOP	
;__Lib_FAT32_Driver.c,171 :: 		}
L_FAT32_Dev_Multi_Read_Start6:
;__Lib_FAT32_Driver.c,172 :: 		return OK;
MOVZ	R2, R0, R0
;__Lib_FAT32_Driver.c,173 :: 		}
L_end_FAT32_Dev_Multi_Read_Start:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _FAT32_Dev_Multi_Read_Start
_FAT32_Dev_Multi_Read_Stop:
;__Lib_FAT32_Driver.c,185 :: 		int8 FAT32_Dev_Multi_Read_Stop()
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;__Lib_FAT32_Driver.c,187 :: 		if (Mmc_Multi_Read_Stop() != OK)
JAL	_Mmc_Multi_Read_Stop+0
NOP	
ANDI	R2, R2, 65535
BNE	R2, R0, L__FAT32_Dev_Multi_Read_Stop27
NOP	
J	L_FAT32_Dev_Multi_Read_Stop7
NOP	
L__FAT32_Dev_Multi_Read_Stop27:
;__Lib_FAT32_Driver.c,189 :: 		return ERROR;
ORI	R2, R0, 255
J	L_end_FAT32_Dev_Multi_Read_Stop
NOP	
;__Lib_FAT32_Driver.c,190 :: 		}
L_FAT32_Dev_Multi_Read_Stop7:
;__Lib_FAT32_Driver.c,191 :: 		return OK;
MOVZ	R2, R0, R0
;__Lib_FAT32_Driver.c,192 :: 		}
L_end_FAT32_Dev_Multi_Read_Stop:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _FAT32_Dev_Multi_Read_Stop
_FAT32_Dev_Multi_Read_Sector:
;__Lib_FAT32_Driver.c,205 :: 		int8 FAT32_Dev_Multi_Read_Sector(char* buf)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;__Lib_FAT32_Driver.c,207 :: 		Mmc_Multi_Read_Sector(buf);
JAL	_Mmc_Multi_Read_Sector+0
NOP	
;__Lib_FAT32_Driver.c,208 :: 		return OK;
MOVZ	R2, R0, R0
;__Lib_FAT32_Driver.c,209 :: 		}
L_end_FAT32_Dev_Multi_Read_Sector:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _FAT32_Dev_Multi_Read_Sector
_FAT32_Put_Char:
;__Lib_FAT32_Driver.c,276 :: 		int8 FAT32_Put_Char(char ch)
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;__Lib_FAT32_Driver.c,278 :: 		UART_Write(ch);
ANDI	R25, R25, 255
JAL	_UART_Write+0
NOP	
;__Lib_FAT32_Driver.c,279 :: 		return OK;
MOVZ	R2, R0, R0
;__Lib_FAT32_Driver.c,280 :: 		}
L_end_FAT32_Put_Char:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _FAT32_Put_Char
_FAT32_Get_Char:
;__Lib_FAT32_Driver.c,290 :: 		int8 FAT32_Get_Char(char *ch)
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;__Lib_FAT32_Driver.c,292 :: 		if (1 == UART_Data_Ready())
SW	R25, 4(SP)
JAL	_UART_Data_Ready+0
NOP	
LW	R25, 4(SP)
ANDI	R3, R2, 65535
ORI	R2, R0, 1
BEQ	R3, R2, L__FAT32_Get_Char31
NOP	
J	L_FAT32_Get_Char8
NOP	
L__FAT32_Get_Char31:
;__Lib_FAT32_Driver.c,294 :: 		*ch = UART_Read();
SW	R25, 4(SP)
JAL	_UART_Read+0
NOP	
LW	R25, 4(SP)
SB	R2, 0(R25)
;__Lib_FAT32_Driver.c,295 :: 		return OK;
MOVZ	R2, R0, R0
J	L_end_FAT32_Get_Char
NOP	
;__Lib_FAT32_Driver.c,296 :: 		}
L_FAT32_Get_Char8:
;__Lib_FAT32_Driver.c,297 :: 		return ERROR;
ORI	R2, R0, 255
;__Lib_FAT32_Driver.c,298 :: 		}
L_end_FAT32_Get_Char:
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _FAT32_Get_Char
