//#include <built_in.h>
#include "MP3_driver.h"
#include "resources.h"

void InitMCU(){
  CM1CON  = 0;                    // Turn off comparators
  CM2CON  = 0;
  AD1PCFG = 0xff;                 // Make all inputs digital

  PMMODE = 0;
  PMAEN  = 0;
  PMCON  = 0;  // WRSP: Write Strobe Polarity bit
  PMMODEbits.MODE = 2;     // Master 2
  PMMODEbits.WAITB = 0;
  PMMODEbits.WAITM = 1;
  PMMODEbits.WAITE = 0;
  PMMODEbits.MODE16 = 1;   // 16 bit mode
  PMCONbits.CSF = 0;
  PMCONbits.PTRDEN = 1;
  PMCONbits.PTWREN = 1;
  PMCONbits.PMPEN = 1;
  TFT_Set_Active(Set_Index,Write_Command,Write_Data);
  TFT_Init(320, 240);
  
  Delay_ms(1000);
}

void main(){
  InitMCU();
  TFT_Fill_Screen(CL_WHITE);
  MP3_Start();
  if (Mmc_Fat_Init() == 0) {
    StartPlayingFile("Oxygene.mp3");
  }
  while(1);
}